﻿/**************************************************************************
'*							                                    		  *
'*  Ｃ＃ 手書き文字認識サンプルプログラム1  Version 1  2014年(平成26年)1月   *
'*					                                    			      *
'*************************************************************************/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Windows.Forms;   　　　　　　  // 参照設定で追加　MessageBoxを表示する為
using System.Runtime.InteropServices;      // ＤＬＬを使用する時必要

namespace ConsoleApplication1
{
    static class Program
    {
        /*************************************************************************
        '*             手書き文字認識関数の宣言                                    *
        '************************************************************************/
        // OPEN関数の宣言
        [DllImport("HandWrite.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int HandWrite_Library_Open(String path);

        // 文字認識関数1の宣言
        [DllImport("HandWrite.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int HandWrite_Pattern_Recognition1(int tot,[In]COORDINATE[] pstrk);

        // 文字認識関数2の宣言
        [DllImport("HandWrite.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int HandWrite_Pattern_Recognition2(int num,ref int KCD, ref double PROB);

        // 登録関数の宣言
        [DllImport("HandWrite.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int HandWrite_Pattern_Entry(int tot,[In]COORDINATE[] pstrk,string kanji);

        // CLOSE関数の宣言
        [DllImport("HandWrite.dll", CallingConvention = CallingConvention.Cdecl)]
        static extern int HandWrite_Library_Close();
        /*************************************************************************
        '*             手書き文字認識の為の構造体の定義                            *
        '************************************************************************/
        // 入力データの為の構造体
        // [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public struct COORDINATE                 // 入力データの為の構造体
        {
            public short PSTATUS;    // ペンの状態：1=ペンダウン, 2=ペン移動, 3=ペンＵＰ
            public short X;          // X座標
            public short Y;          // Y座標
        }
        /*************************************************************************
        *				                                    					 *
        *                    プログラム のスタート                                *                           
        *								                                    	 *
        *************************************************************************/  
        // [STAThread] 
        static void Main(string[] args)
        {          
            COORDINATE[] pstrk;pstrk = new COORDINATE[1000]; // COORDINATEの配列作成
            // 配列要素のCOORDINATEのインスタンス生成
            // for (int i = 0; i < 1000; i++) pstrk[i] = new COORDINATE();
           
        /*---------------結 果 の 表 示---------------------------------------------*/

            Console.WriteLine("-----Ｃ＃ 手書き文字認識 サンプル１ Version 1.0 の結果-------------");
            Console.WriteLine(" ");
        /*************************************************************************
        *       文字認識ライブラリのOPEN---パス名は各アプリケーションで異なります   *
        *************************************************************************/          
            string hPath = System.IO.Directory.GetCurrentDirectory();
            hPath=hPath + "\\";                     // hPath=カレントディレクトリ
            Console.WriteLine("   パス名＝{0}", hPath);

            int j = HandWrite_Library_Open(hPath);if ( j < 0 ) return;
            if (j == 1)
            {
                string msg = "OPENに成功しました。リターンコード ＝ " + j.ToString();
                MessageBox.Show(msg, "文字認識ライブラリのOPEN");
            }
            else
            {
                string msg = "OPENに成功しました。残り日数 ＝ " + j.ToString() + "日";
                MessageBox.Show(msg, "文字認識ライブラリのOPEN");
            }
        /*************************************************************************
        *             入力データのセット      テストデータ=へ                      *
        *************************************************************************/
            int tot = 4;                                              // tot=点列数トタル                                                              // 1文字の点列総数
            /*----- 第1ストローク----------------------------------------------------------*/
            pstrk[0].PSTATUS = 1; pstrk[0].X = 0; pstrk[0].Y = 12;    // ペンダウン
            pstrk[1].PSTATUS = 2; pstrk[1].X = 12; pstrk[1].Y = 0;    // ペン移動
            pstrk[2].PSTATUS = 2; pstrk[2].X = 22; pstrk[2].Y = 10;   // ペン移動
            pstrk[3].PSTATUS = 3; pstrk[3].X = 28; pstrk[3].Y = 16;   // ペンＵＰ
        /*************************************************************************
        *             手書き文字認識 及び 認識結果の表示                           *
        *************************************************************************/
            int rcode = HandWrite_Pattern_Recognition1(tot, pstrk);  // 手書き文字認識の実行
            if (rcode < 1) return;                                   // 認識に失敗

            int ret,KCD=0;double PROB=0.0;byte[] sjis = new byte[2];string unic="";

            Console.WriteLine(" "); Console.WriteLine("             認識文字   ミスマッチ測度");
            Console.WriteLine(" ");
            int k; string s1; string s2,kanji; string F2 = "F2";
            for (int i = 0; i < rcode; i++)
            {
                ret = HandWrite_Pattern_Recognition2(i, ref KCD, ref PROB);
                k = i + 1;
                s1 = "   第 " + k.ToString() + " 候補    ";

                /*--------Shift Jisコードをユニコード文字へ変換-------------*/
                sjis[0] = (byte)(KCD/256); sjis[1] = (byte)(KCD%256);
                unic = System.Text.Encoding.GetEncoding("Shift_jis").GetString(sjis);
                /*--------------------------------------------------------*/

                s2 = PROB.ToString(F2);
                s1 = s1 + unic + "         " + s2;
                Console.Write(s1);Console.WriteLine(" ");

            /*--------手書き文字登録テスト　この関数を実行すると文字認識ライブラリの内容が変わります。  */
                if (i != 0) continue;
                kanji = "へ"; 
            //    ret=HandWrite_Pattern_Entry(tot, pstrk,kanji);

            /*-----------------------------------------------------------------------------------*/  

            }
            string msg1 = "OK  候補数 ＝ " + rcode.ToString();
            MessageBox.Show(msg1, "文字認識の実行");
            rcode = HandWrite_Library_Close();

        }    //   static void Main(string[] args) の終わり
    }　　　  //   static class Program の終わり
}           //    namespace ConsoleApplication1 の終わり
    


