﻿/**************************************************************************
'*							                                    		  *
'*  Ｃ＃ 手書き文字認識サンプルプログラム2  Version 1  2014年(平成26年)1月   *
'*					                                    			      *
'*************************************************************************/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;      // ＤＬＬを使用する時必要

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
    /*************************************************************************
    '*             グローバル変数の定義                                       *
    '************************************************************************/
        Pen pen = new Pen(Color.Black, 1);  // Penの新しいインスタンスを生成(色と線の太さを定義)
        Point pt = new Point();             // Pointの新しいインスタンスを生成
        bool ms_flg = false;　　　　　　　　 // 左クリックされているかどうかのフラグ　falseで左クリックされていない　
        public int pnt = 0; public int pntsv = 0;
        public int count = 0;
        int ret, KCD = 0; double PROB = 0.0; byte[] sjis = new byte[2]; 
        string unic = "";
        Font fobj = new Font("MS UI Gothic", 12);
        public Bitmap bmp1; public Bitmap bmp2;
        public Graphics _Gobj1; public Graphics _Gobj2;
    /*************************************************************************
    '*             手書き文字認識の為の構造体の定義                            *
    '************************************************************************/
        // 入力データの為の構造体
        // [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public struct COORDINATE                 
        {
            public short PSTATUS;    // ペンの状態：1=ペンダウン, 2=ペン移動, 3=ペンＵＰ
            public short X;          // X座標
            public short Y;          // Y座標
        }
        public static COORDINATE[] pstrk;  
    /*************************************************************************
    '*             手書き文字認識関数の宣言                                    *
    '************************************************************************/
        // OPEN関数の宣言
        [DllImport("HandWrite.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int HandWrite_Library_Open(String path);

        // 文字認識関数1の宣言
        [DllImport("HandWrite.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int HandWrite_Pattern_Recognition1(int tot, [In]COORDINATE[] pstrk);

        // 文字認識関数2の宣言
        [DllImport("HandWrite.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int HandWrite_Pattern_Recognition2(int num, ref int KCD, ref double PROB);

        // 登録関数の宣言
        [DllImport("HandWrite.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int HandWrite_Pattern_Entry(int tot, [In]COORDINATE[] pstrk, string kanji);

        // CLOSE関数の宣言
        [DllImport("HandWrite.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int HandWrite_Library_Close();
        /*************************************************************************
        *							                                    		 *
        *                      Form1 のスタート                                   *                           
        *							                                              *
        *************************************************************************/  
        public Form1()
        {

            InitializeComponent(); 
             
        }     // public Form1()の終了        
        /*******************************************************************************
        *										                                       *                   	
        *  　　　Form1_Loadイベント処理(文字認識ライブラリのOPEN,デモデータの処理)   　　　*
        *										                                       *
        *******************************************************************************/
        private void Form1_Load(object sender, EventArgs e)
        {
            string hPath = System.IO.Directory.GetCurrentDirectory();
            hPath = hPath + "\\";                     // hPath=カレントディレクトリ

            int j = HandWrite_Library_Open(hPath);    // 文字認識ライブラリのOPEN
            if (j < 0)  Application.Exit();

            if (j == 1)
            {
                string msg = "OPENに成功しました。リターンコード ＝ " + j.ToString();
                msg = msg + '\n' + "パス名＝" + hPath;
                MessageBox.Show(msg, "文字認識ライブラリのOPEN");
            }
            else
            {
                string msg = "OPENに成功しました。残り日数 ＝ " + j.ToString() + "日";
                msg = msg + '\n' + "パス名＝" + hPath;
                MessageBox.Show(msg, "文字認識ライブラリのOPEN");
            }
            pstrk = new COORDINATE[5000];　　  　// 1文字分のエリアを確保
        /*************************************************************************
        *             デモデータのセット、描画及び認識     デモデータ=力            *
        *************************************************************************/
            pnt = 6;                                                     // 1文字の点列総数
        /*----- 第1ストローク----------------------------------------------------------*/
            pstrk[0].PSTATUS = 1 ; pstrk[0].X = 0 ; pstrk[0].Y =13;      // ペンダウン 
            pstrk[1].PSTATUS = 2 ; pstrk[1].X = 32 ; pstrk[1].Y =10;     // ペン移動 
            pstrk[2].PSTATUS = 3 ; pstrk[2].X = 29 ; pstrk[2].Y = 42;    // ペンＵＰ 
        /*----- 第2ストローク----------------------------------------------------------*/
            pstrk[3].PSTATUS = 1 ; pstrk[3].X = 20 ; pstrk[3].Y = 0;     // ペンダウン
            pstrk[4].PSTATUS = 2 ; pstrk[4].X = 13 ; pstrk[4].Y = 13;    // ペン移動
            pstrk[5].PSTATUS = 3; pstrk[5].X = 7; pstrk[5].Y = 42;       // ペンＵＰ  */

        /*------デモデータの描画及び認識---------------------------------------------*/
            Show(); Cre_Gobj1_ClsPic1(); 
            Point pt1 = new Point(); 
            for (int i = 0; i < pnt; i++)
            {
                pt1.X = pstrk[i].X+70; pt1.Y = pstrk[i].Y+60;
                if (pstrk[i].PSTATUS == 1)
                {
                    pt.X = pt1.X; pt.Y = pt1.Y;
                }
                _Gobj1.DrawLine(pen, pt, pt1);
                pt.X = pt1.X; pt.Y = pt1.Y;
            }
            pictureBox1.Refresh(); Result();

        }        // Form1_Loadイベントの終了
        /*******************************************************************************
        *								                                    　　　　　　*	
        *  pictureBox1_MouseDownイベント処理(文字認識,結果の表示,ペンダウンの座標を格納)   *
        *								                                        	    *
        ********************************************************************************/
        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            /*************************************************************************
            *   マウスの左ボタンが押された(pictureBox1クリア,ペンダウンの座標を格納      *
            *************************************************************************/
            if (e.Button == MouseButtons.Left)    // 左ボタンが押された
            {
                if (pnt == 0)  Cre_Gobj1_ClsPic1();

                /*-----ms_flg=左クリックされているかどうかのフラグ　trueで左クリックされている----- */
                ms_flg = true;

                /*-----ペンダウンの座標をpstrkに格納----- */
                pt.X = e.X; pt.Y = e.Y;
                pstrk[pnt].PSTATUS = 1;          // ペンダウン
                pstrk[pnt].X=(short)e.X ; pstrk[pnt].Y=(short)e.Y;
                pntsv=pnt; pnt++;
            }
            /*************************************************************************
            *    マウスの右ボタンが押された(手書き文字文字認識,認識結果の表示)           *
            *************************************************************************/
            if (e.Button == MouseButtons.Right) Result();     // 右ボタンが押された

        }         // pictureBox1_MouseDownの終了
        /********************************************************************************
         *                                                                              *	                                       									    *	
        *  pictureBox1_MouseMoveイベント処理(入力された文字を描画,ペン移動の座標を格納)    *
        *						                                      				    *
        ********************************************************************************/
        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            if (ms_flg == false) return;　            // 左クリックされていない
            if (pt.X == e.X && pt.Y == e.Y) return;   // 前と同じ座標

            /*-----入力された文字を描く----- */
            _Gobj1.DrawLine(pen, pt, new Point(e.X, e.Y));
            pictureBox1.Refresh();

            /*-----ペン移動の座標をpstrkに格納----- */
            pstrk[pnt].PSTATUS = 2;          // ペン移動
            pstrk[pnt].X = (short)e.X;
            pstrk[pnt].Y = (short)e.Y;pnt++;
            pt.X = e.X;pt.Y = e.Y;

        }         // pictureBox1_MouseMoveの終了
        /*******************************************************************************
        *										                                       *	
        *          pictureBox1_MouseUpイベント処理(ペンUpの座標をpstrkに格納)            *
        *						                                    				   *
        *******************************************************************************/
        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            if (ms_flg == false) return;    // 左クリックでない
            ms_flg = false; // ms_flg=左クリックされているかどうかのフラグ　falseで左クリックされていない
            if ( (pnt - pntsv) < 3 )        // 1ストロークの点列数が3より小の時は無視
            {
                pnt = pntsv ; return;
            }
            pstrk[pnt].PSTATUS = 3;        // ペンＵＰ
            pstrk[pnt].X = (short)e.X;pstrk[pnt].Y = (short)e.Y;pnt++;

         }         // pictureBox1_MouseUpの終了 
        /*******************************************************************************
        *									                                           *	
        *          _Gobj1 の生成、bmp1 及び PictureBox1のクリアー                       *
        *									                                           *
        *******************************************************************************/
        private void Cre_Gobj1_ClsPic1()
        {
            if (Disposing)
            {
                _Gobj1.Dispose();   // _Gobj1 に関するGraphicsで使ったメモリの開放
            }
            bmp1 = new Bitmap(pictureBox1.Width, pictureBox1.Height);
            pictureBox1.BackgroundImage = bmp1;
            _Gobj1 = Graphics.FromImage(pictureBox1.BackgroundImage);
            pictureBox1.Refresh();
        }
        /******************************************************************************
        *									                                          *	
        *             文字認識及び結果をPictureBox2に表示                              *
        *									                                          *
        ******************************************************************************/
        private void Result()
        {
            if (  pnt == 0 )  return;

            int rcode = HandWrite_Pattern_Recognition1(pnt, pstrk);  // 手書き文字認識の実行
            if (rcode < 1)                                                 // 認識に失敗
            {
                pnt = 0 ; return;
            }

            /*------認識結果とミスマッチ測度をpictureBox2に表示-------*/
            _ClsPic2(); if (rcode > 8) rcode = 8;
            int i; string s1; string F2 = "F2";
            for (i = 0; i < rcode; i++)
            {
                ret = HandWrite_Pattern_Recognition2(i, ref KCD, ref PROB);
                sjis[0] = (byte)(KCD / 256); sjis[1] = (byte)(KCD % 256);
                unic = System.Text.Encoding.GetEncoding("Shift_jis").GetString(sjis);

                s1 = PROB.ToString(F2);
                if ( i == 0 )
                {
                    _Gobj2.DrawString(unic, fobj, Brushes.Red, 30, 20 * i);
                    _Gobj2.DrawString(s1, fobj, Brushes.Red, 96, 20 * i);
                }
                else
                {
                    _Gobj2.DrawString(unic, fobj, Brushes.White, 30, 20 * i);
                    _Gobj2.DrawString(s1, fobj, Brushes.White, 96, 20 * i);
                }
            }
            pictureBox2.Refresh(); _Gobj2.Dispose();     // _Gobj2 に関するGraphicsで使ったメモリの開放
            pnt=0;
        }
    /************************************************************************************
    '*          pictureBox2 描画 の準備                                                  *
    '***********************************************************************************/
        private void _ClsPic2()
        {
            bmp2 = new Bitmap(pictureBox2.Width, pictureBox2.Height);
            pictureBox2.BackgroundImage = bmp2;
            _Gobj2 = Graphics.FromImage(pictureBox2.BackgroundImage);
        }
    /************************************************************************************
    '*									                                                *	
    '*          認識ToolStripMenuItem_Clickイベント処理(認識メニューが押された)           *
    '*									                                                *
    '***********************************************************************************/
        private void 認識ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Result();
            if ( count != 0 )  return;
            MessageBox.Show("右クリックでも結果を表示する事が出来ます。", "結果の表示");
            count ++;
        }
    /************************************************************************************
    '*									                                                *	
    '*          クリアToolStripMenuItem_Clickイベント処理(クリアメニューが押された)        *
    '*									                                                *
    '***********************************************************************************/
        private void クリアToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Cre_Gobj1_ClsPic1(); _ClsPic2();
            pictureBox2.Refresh(); _Gobj2.Dispose();　　// _Gobj2 に関するGraphicsで使ったメモリの開放
            pnt = 0;
        }
    /************************************************************************************
    '*									                                                *	
    '*          ヘルプToolStripMenuItem_Clickイベント処理(ヘルプメニューが押された)        *
    '*									                                                *
    '***********************************************************************************/
        private void ヘルプToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Help.ShowHelp(new Control(), "HandWrite_Dll仕様書.chm");
        }

    /*-------------Form1_MouseDownイベント----------------------------*/
        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right) Result();    // 右ボタン押された
        }

    /*-------------PictureBox2_MouseDownイベント---------------------------*/
        private void pictureBox2_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right) Result();    // 右ボタン押された
        }

    /*-------------Form1_FormClosingイベント----------------------------*/
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (Disposing)
            {
                _Gobj1.Dispose();   // _Gobj1 に関するGraphicsで使ったメモリの開放
            }
            int rcode = HandWrite_Library_Close();
        }
    
    }              // public partial class Form1の終了
}                  // namespace WindowsFormsApplication1の終了








