﻿'*******************************************************************************
'*							                                    		       *
'*   ＶＢ 手書き文字認識サンプルプログラム1  Version 2  2014年(平成26年) 1月   *
'*					                                    				       *
'*******************************************************************************
Module Module1

    ' 入力データの為の構造体
    Structure COORDINATE              ' 旧バージョンでは Structure ---> Type
        Dim PSTATUS As Short          '  ペンの状態：1=ペンダウン, 2=ペン移動, 3=ペンＵＰ */
        Dim X As Short                '  X座標 
        Dim Y As Short                '  Y座標
    End Structure

    ' OPEN関数の宣言
    Declare Function HandWrite_Library_Open Lib "HandWrite.dll" ( _
       ByVal nPath As String) As Integer    'VB 2008 Express Editionでは Longは8バイト(64ビット)だからIntegerに変更

    ' 文字認識関数1の宣言
    Declare Function HandWrite_Pattern_Recognition1 Lib "HandWrite.dll" ( _
       ByVal TOT As Integer, ByVal LPT1() As COORDINATE) As Integer

    ' 文字認識関数2の宣言
    Declare Function HandWrite_Pattern_Recognition2 Lib "HandWrite.dll" ( _
       ByVal NUM As Integer, ByRef KCD As Integer, ByRef PROB As Double) As Integer

    ' 登録関数の宣言
    Declare Function HandWrite_Pattern_Entry Lib "HandWrite.dll" ( _
       ByVal TOT As Integer, ByVal LPT1() As COORDINATE, ByVal kanji As String) As Integer

    ' CLOSE関数の宣言
    Declare Function HandWrite_Library_Close Lib "HandWrite.dll" () As Integer

    Sub Main()
        Dim hPath As String
        Dim rcode, KCD, tot, i As Integer
        Dim PROB As Double
        Dim pstroke(3000) As COORDINATE
        ' Dim presult As CANDIDATE
        Dim aa(2) As Integer
        ' Dim jKanji(16) As String
        '*---------------結 果 の 表 示---------------------------------------------

        Console.WriteLine("-----ＶＢ 手書き文字認識 サンプル１ Version 2.0 の結果-------------")
        Console.WriteLine(" ")
        '*************************************************************************
        '*   文字認識ライブラリのOPEN---パス名は各アプリケーションで異なります   *
        '*************************************************************************
        'hPath = "c:\Development\HandWrite_Dll\"
        hPath = CurDir() & "\"                              ' CurDir=カレントフォルダ
        Console.WriteLine("   パス名＝" & hPath)
        rcode = HandWrite_Library_Open(hPath)               ' 文字認識ライブラリのOPEN
        If rcode < 0 Then Exit Sub
        If rcode = 1 Then
            Dim msg = "OPENに成功しました。リターンコード＝" & rcode
            MsgBox(msg, 64, "文字認識ライブラリのOPEN")     ' 64=情報
            ' 16=警告 32=問い合わせ 48=注意 64=情報
        Else
            Dim msg = "OPENに成功しました。残り日数＝" & rcode & "日"
            MsgBox(msg, 64, "文字認識ライブラリのOPEN")     
        End If
        '*************************************************************************
        '*             入力データのセット      テストデータ　一                  *
        '*************************************************************************
        '----- 第1ストローク----------------------------------------------------------
        tot = 3
        pstroke(0).PSTATUS = 1         ' ペンダウン 
        pstroke(0).X = 0 : pstroke(0).Y = 0
        pstroke(1).PSTATUS = 2         ' ペン移動 
        pstroke(1).X = 5 : pstroke(1).Y = 0
        pstroke(2).PSTATUS = 3         ' ペンＵＰ 
        pstroke(2).X = 10 : pstroke(2).Y = 0
        '*************************************************************************
        '*             手書き文字認識 及び 認識結果の表示                        *
        '*************************************************************************
        Dim ret As Integer : Dim Mychr As Char                                                          ' 1文字の点列総数 
        rcode = HandWrite_Pattern_Recognition1(tot, pstroke)     ' 手書き文字認識の実行
        If rcode < 1 Then Exit Sub ' 認識に失敗
        Console.WriteLine(" ") : Console.WriteLine("             認識文字   ミスマッチ測度")
        For i = 0 To rcode - 1
            ret = HandWrite_Pattern_Recognition2(i, KCD, PROB)
            Mychr = Chr(KCD)          ' 認識結果はpresult.KanjiにIntegerでは入っている
            Console.WriteLine("   第" & Str(i + 1) & " 候補    " & Mychr & "         " & Str(PROB))

            '*--------手書き文字登録テスト　この関数を実行すると文字認識ライブラリの内容が変わります。  
            If i = 0 Then
                '  ret = HandWrite_Pattern_Entry(tot, pstroke, Mychr)     ' 手書き文字登録の実行
            End If
            '*-------------------------------------------------------------------------------------  

        Next
        MsgBox("OK  候補数 ＝ " & Str(rcode), 64, "文字認識の実行")   ' 64=情報
        rcode = HandWrite_Library_Close()
    End Sub
End Module
